jQuery(document).ready(function($) {
    //alert(scriptVars.mapExists);
    // Initialize map
    var map;
    var default_marker;
    var marker;
    var marker_count = 0;
    function initialize() {
        marker_count = 1;
        if (scriptVars.mapExists) {
            var defaultLatlng = new google.maps.LatLng(scriptVars.mapLat, scriptVars.mapLng);
            $('#map_message').html('<div class="dashicons dashicons-location"></div> To adjust the property location on the map, click and drag the marker to its a new position and click \'Update\'.');
        } else {
            var defaultLatlng = new google.maps.LatLng(scriptVars.maphotelLat,scriptVars.maphotelLng);
            $('#map_message').html('<div class="dashicons dashicons-location"></div> To set the property location, click a position on the map.  You can zoom in and/or change the \'Map\' type to select a location accurately.');
        }
        var myOptions = {
            zoom: 15,
            center: defaultLatlng,
            mapTypeId: google.maps.MapTypeId.ROADMAP
        }
        map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
        
        
        // Set default marker for hotel location
        var image = new google.maps.MarkerImage(scriptVars.template+"/images/marker.png",
            new google.maps.Size(30.0, 42.0),
            new google.maps.Point(0, 0),
            new google.maps.Point(12.0, 21.0)
        );
        var shadow = new google.maps.MarkerImage(scriptVars.template+"/images/shadow-hotel-main.png",
            new google.maps.Size(46.0, 42.0),
            new google.maps.Point(0, 0),
            new google.maps.Point(12.0, 21.0)
        );
        default_marker = new google.maps.Marker({
            position: new google.maps.LatLng(scriptVars.hotelMap.lat,scriptVars.hotelMap.lng),
            map: map,
            icon: image,
            shadow: shadow
        });

        if (scriptVars.mapExists) {
            marker = new google.maps.Marker({
                position: defaultLatlng,
                draggable: true,
                map: map
            });
            google.maps.event.addListener(marker, 'dragend', function() {
                updateMarkerPosition(marker.getPosition());
            });
        }

        if (!scriptVars.mapExists) {
            google.maps.event.addListener(map, "click", function(event) {
                if (scriptVars.myCounter == 0) {
                    placeMarker(event.latLng);
                    scriptVars.myCounter++;
                }
                google.maps.event.addListener(marker, 'dragend', function() {
                    updateMarkerPosition(marker.getPosition());
                });
            });
        }

    }
    ; // end initialize

    // Remove parentheses from map coordinates
    function removeParentheses(text) {
        textval = text.replace(/"/g, "").replace(/'/g, "").replace(/\(|\)/g, "");
        return textval;
    }

    // Place marker at specified location
    function placeMarker(location) {
        marker = new google.maps.Marker({
            position: location,
            draggable: true,
            map: map
        });
        map.setCenter(location);
        updateMarkerPosition(location);
    };

    // Update coordinates after placement or dragging
    function updateMarkerPosition(location) {
        $('#meta_geocode').val(removeParentheses(String(location)));
    }
    
    $('#remove_geocode').on('click', function(){
        $('#meta_geocode').val('');        
    });

    if ($('#map_canvas').length){
        google.maps.event.addDomListener(window, "load", initialize);
    }

});